> ## Documentation Index > Fetch the complete documentation index at: https://support.tulip.co/llms.txt > Use this file to discover all available pages before exploring further. # /api/stations/v1/station-groups/{stationGroupId}/stations > Updates the list of stations in a station group. ## OpenAPI ````json PATCH /api/stations/v1/station-groups/{stationGroupId}/stations { "openapi": "3.0.3", "info": { "title": "Tulip API", "version": "v1" }, "tags": [ { "name": "machines", "description": "An API for managing machines and their types" }, { "name": "stations", "description": "An API for managing and updating stations." }, { "name": "users", "description": "An API for managing users and their roles/permissions." } ], "paths": { "/api/stations/v1/station-groups/{stationGroupId}/stations": { "patch": { "operationId": "updateStationGroupStations", "description": "Updates the list of stations in a station group.", "tags": [ "stations" ], "x-tulip-visibility": "public", "requestBody": { "description": "A directive containing the list of stations to add to the group or remove from it.", "required": "true", "content": { "application/json": { "schema": { "$ref": "#/components/schemas/StationListUpdateDirective" } } } }, "parameters": [ { "name": "stationGroupId", "description": "The id of the station group that the stations will be updated for.", "in": "path", "required": "true", "schema": { "$ref": "#/components/schemas/StationGroupId" } } ], "responses": { "204": { "description": "The stations were successfully updated in the station group.\n" }, "400": { "description": "An error occurred. The Tulip error codes `generic.customerIdRequired`, `generic.workspaceIdRequired`, `generic.invalidParams`, `http.invalidBodyJson`, `http.invalidHeaders`, and `http.multiValueHeader` all use the 400 HTTP status code. See the documentation of the response content schema for details on these specific Tulip errors that could result in this status code.", "content": { "application/json": { "schema": { "oneOf": [ { "allOf": [ { "$ref": "#/components/schemas/ApiError" }, { "type": "object", "description": "The request was missing information about the Tulip customer context.\n\nThis error is not automatically retryable.", "properties": { "errorCode": { "enum": [ "generic.customerIdRequired" ] }, "retryable": { "enum": [ "false" ] } }, "required": [ "errorCode", "retryable" ] } ] }, { "allOf": [ { "$ref": "#/components/schemas/ApiError" }, { "type": "object", "description": "The request was missing information about the Tulip workspace context.\n\nThis error is not automatically retryable.", "properties": { "errorCode": { "enum": [ "generic.workspaceIdRequired" ] }, "retryable": { "enum": [ "false" ] } }, "required": [ "errorCode", "retryable" ] } ] }, { "allOf": [ { "$ref": "#/components/schemas/ApiError" }, { "type": "object", "description": "The request parameters were invalid.\n\nThis error is not automatically retryable.", "properties": { "errorCode": { "enum": [ "generic.invalidParams" ] }, "retryable": { "enum": [ "false" ] } }, "required": [ "errorCode", "retryable" ] } ] }, { "allOf": [ { "$ref": "#/components/schemas/ApiError" }, { "type": "object", "description": "The HTTP request body could not be decoded as JSON.\n\nThis error is not automatically retryable.", "properties": { "errorCode": { "enum": [ "http.invalidBodyJson" ] }, "retryable": { "enum": [ "false" ] } }, "required": [ "errorCode", "retryable" ] } ] }, { "allOf": [ { "$ref": "#/components/schemas/ApiError" }, { "type": "object", "description": "The HTTP request headers were invalid.\n\nThis error is not automatically retryable.", "properties": { "errorCode": { "enum": [ "http.invalidHeaders" ] }, "retryable": { "enum": [ "false" ] } }, "required": [ "errorCode", "retryable" ] } ] }, { "allOf": [ { "$ref": "#/components/schemas/ApiError" }, { "type": "object", "description": "An HTTP request header contained multiple values.\n\nThis error is not automatically retryable.", "properties": { "errorCode": { "enum": [ "http.multiValueHeader" ] }, "details": { "type": "object", "properties": { "headerName": { "description": "The name of the given HTTP header which had multiple values.\n", "type": "string" } }, "required": [ "headerName" ] }, "retryable": { "enum": [ "false" ] } }, "required": [ "errorCode", "retryable", "details" ] } ] } ] } } } }, "401": { "description": "The request was missing required authentication information.\n\nThis error is not automatically retryable.", "content": { "application/json": { "schema": { "allOf": [ { "$ref": "#/components/schemas/ApiError" }, { "type": "object", "description": "The request was missing required authentication information.\n\nThis error is not automatically retryable.", "properties": { "errorCode": { "enum": [ "generic.authRequired" ] }, "retryable": { "enum": [ "false" ] } }, "required": [ "errorCode", "retryable" ] } ] } } } }, "404": { "description": "The requested resource was not found.\n\nThis error is not automatically retryable.", "content": { "application/json": { "schema": { "allOf": [ { "$ref": "#/components/schemas/ApiError" }, { "type": "object", "description": "The requested resource was not found.\n\nThis error is not automatically retryable.", "properties": { "errorCode": { "enum": [ "generic.notFound" ] }, "retryable": { "enum": [ "false" ] } }, "required": [ "errorCode", "retryable" ] } ] } } } }, "422": { "description": "An error occurred. The Tulip error codes `generic.archivedResourceUnsupportedOperation`, `stations.invalidReferencedResourceId`, and `stations.stationGroupStationsLimitReached` all use the 422 HTTP status code. See the documentation of the response content schema for details on these specific Tulip errors that could result in this status code.", "content": { "application/json": { "schema": { "oneOf": [ { "allOf": [ { "$ref": "#/components/schemas/ApiError" }, { "type": "object", "description": "This operation is not permitted on the requested resource because it is archived.\n\nThis error is not automatically retryable.", "properties": { "errorCode": { "enum": [ "generic.archivedResourceUnsupportedOperation" ] }, "retryable": { "enum": [ "false" ] } }, "required": [ "errorCode", "retryable" ] } ] }, { "allOf": [ { "$ref": "#/components/schemas/ApiError" }, { "type": "object", "description": "One or more ids referenced resources that were invalid. Please make sure\nall ids reference resources that exist.\n\nThis error is not automatically retryable.", "properties": { "errorCode": { "enum": [ "stations.invalidReferencedResourceId" ] }, "details": { "type": "array", "description": "A list of invalid referenced resources.\n", "items": { "type": "object", "properties": { "resourceId": { "description": "The id of the invalid resource.\n", "type": "string" }, "details": { "description": "Details about why the resource was invalid.\n", "type": "string" } }, "required": [ "resourceId" ] } }, "retryable": { "enum": [ "false" ] } }, "required": [ "errorCode", "retryable", "details" ] } ] }, { "allOf": [ { "$ref": "#/components/schemas/ApiError" }, { "type": "object", "description": "The number of stations in a station group has reached the allowed limit.\n\nThis error is not automatically retryable.", "properties": { "errorCode": { "enum": [ "stations.stationGroupStationsLimitReached" ] }, "details": { "type": "object", "properties": { "workspaceId": { "type": "string" }, "stationGroupId": { "type": "string" }, "limit": { "type": "number", "description": "The limit of how many stations can be in the station group." }, "current": { "type": "number", "description": "The current number of stations in the station group." } }, "required": [ "workspaceId", "stationGroupId" ] }, "retryable": { "enum": [ "false" ] } }, "required": [ "errorCode", "retryable", "details" ] } ] } ] } } } }, "429": { "description": "Too many requests have been made to this endpoint in a short time period.\n\nThis error is not automatically retryable.", "content": { "application/json": { "schema": { "allOf": [ { "$ref": "#/components/schemas/ApiError" }, { "type": "object", "description": "Too many requests have been made to this endpoint in a short time period.\n\nThis error is not automatically retryable.", "properties": { "errorCode": { "enum": [ "http.endpointRateLimitExceeded" ] }, "details": { "type": "object", "properties": { "details": { "description": "Additional details about this endpoint's rate limits.\n", "type": "string" } } }, "retryable": { "enum": [ "false" ] } }, "required": [ "errorCode", "retryable", "details" ] } ] } } } }, "500": { "description": "An internal server error occurred. Please contact [support@tulip.co](mailto:support@tulip.co)\nif the error persists.\n\nThis error is not automatically retryable.", "content": { "application/json": { "schema": { "allOf": [ { "$ref": "#/components/schemas/ApiError" }, { "type": "object", "description": "An internal server error occurred. Please contact [support@tulip.co](mailto:support@tulip.co)\nif the error persists.\n\nThis error is not automatically retryable.", "properties": { "errorCode": { "enum": [ "generic.internal" ] }, "retryable": { "enum": [ "false" ] } }, "required": [ "errorCode", "retryable" ] } ] } } } } } } } }, "components": { "schemas": { "StationListUpdateDirective": { "type": "object", "description": "Information necessary to add a station to a list of stations or remove the station from it.\n", "properties": { "add": { "description": "An array station IDs to add", "type": "array", "items": { "$ref": "#/components/schemas/StationId" } }, "remove": { "description": "An array of station IDs to remove", "type": "array", "items": { "$ref": "#/components/schemas/StationId" } } }, "example": { "add": [ "swM2aGebq5MjhKafN" ], "remove": [ "DFX2aFe124MjhFaRt" ] } }, "StationGroupId": { "allOf": [ { "$ref": "#/components/schemas/RandomId" }, { "description": "The id of a station group.\n" } ] }, "ApiError": { "description": "An error response returned by a Tulip API.\n", "type": "object", "properties": { "errorCode": { "description": "A machine-readable code identifying the type of error.\n", "type": "string", "pattern": "^[a-zA-Z0-9.]$" }, "message": { "description": "A human-readable description of the error intended for debugging purposes only.\n\nThe exact content of this message is not stable.\n", "type": "string" }, "retryable": { "description": "Whether the request can be automatically retried by the client.\n", "type": "boolean" } }, "required": [ "errorCode", "retryable" ] }, "StationId": { "allOf": [ { "$ref": "#/components/schemas/RandomId" }, { "description": "The id of a station.\n" } ] }, "RandomId": { "description": "A randomly generated unique identifier.\n\nTypically has ~98 bits of entropy.\n", "example": "g56RCoZCtzv7borvp", "type": "string", "pattern": "^[a-zA-Z0-9_]+$" } } } } ````